const { success } = require('../../services/response');
const { loggerError } = require('../../services/logger');
const { getData, setData } = require('../../utils/data-handlers');

const set = async ({ body, ...other }, res, next) => {
  try {
    const data = await setData(body);
    return success(res, 201)(data);
  } catch (error) {
    return loggerError(next, other)(error);
  }
}

const get = async (req, res, next) => {
  try {
    const data = await getData();
    return success(res, 200)(data);
  } catch (error) {
    return loggerError(next, req)(error);
  }
}

module.exports = {
  set,
  get
}