const jwt = require('jsonwebtoken')
const Promise = require('bluebird')
const { jwtSecret } = require('../../config');

const jwtSign = Promise.promisify(jwt.sign)
const jwtVerify = Promise.promisify(jwt.verify)

const sign = (user, options, method = jwtSign) => {
  const fieldsForJWT = ['id'];
  const jwtObject = fieldsForJWT.reduce((acc, elem) => ({ ...acc, [elem]: user[elem] }), {})

  return method(jwtObject, jwtSecret, options)
}

const signSync = (id, options) => sign(id, options, jwt.sign)

const verify = (token) => jwtVerify(token, jwtSecret)

module.exports = {
  signSync,
  verify,
  sign,
}