const path = require('path');
const fs = require('fs');

const { User } = require('../routes/users/model');

const pathToUsersJSON = path.join(__dirname, '..', '..', 'db', 'users.json');
const pathToDataJSON = path.join(__dirname, '..', '..', 'db', 'data.json');

const getAllUsersDataFromDB = () => {
  const rawData = fs.readFileSync(pathToUsersJSON);

  const oldArray = JSON.parse(rawData);
  return oldArray.map(el => new User(el, false))
}

const setDataToFile = (p, d) => fs.writeFileSync(p, JSON.stringify(d, null, 2));

module.exports = {
  getAllUsersDataFromDB,
  addNewUserToDB: async (data) => {
    const newUser = new User(data);

    const oldDataFromJSON = getAllUsersDataFromDB();
    const newData = oldDataFromJSON.concat(newUser);
    setDataToFile(pathToUsersJSON, newData);
    return newUser;
  },
  getData: async () => {
    const rawData = fs.readFileSync(pathToDataJSON);
    return JSON.parse(rawData);
  },
  setData: async (data) => {
    setDataToFile(pathToDataJSON, data);
    return data;
  },
}